<template>
  <div class="gpa-garden">
    <rui-loading v-if="!mapIsReady" fill relative>{{ $t('js.garden.loading_map') }}</rui-loading>

    <rui-toolbars container>
      <template v-if="['draw_patch', 'draw_path'].includes(mode)">
        <rui-toolbar>
          <rui-button icon="stop" :caption="$t('js.layouts.garden.toolbar.stop')" variant="canceling" @click="changeMode('review')" />
        </rui-toolbar>

        <div v-if="modeOptions.shape !== 'Point'" class="-flex text--color-helping -text--smaller">
          {{ $t('js.layouts.garden.toolbar.drawing_lines_help') }}
        </div>
      </template>
      <template v-else>
        <rui-toolbar :label="$t('js.layouts.garden.toolbar.add_patch')" no-label-on-small>
          <rui-button icon="point-plus" :title="$t('js.layouts.garden.side_panel.button_draw_point')" @click="changeMode('select_patch_resource', { shape: 'Point' })" />
          <rui-button icon="polygon-plus" :title="$t('js.layouts.garden.side_panel.button_draw_polygon')" @click="changeMode('select_patch_resource', { shape: 'Polygon', skippable: true })" />
          <rui-button icon="circle-plus" :title="$t('js.layouts.garden.side_panel.button_draw_circle')" @click="changeMode('select_patch_resource', { shape: 'Circle', skippable: true })" />
          <rui-toolbar-separator />
          <rui-button icon="virtual" :title="$t('js.layouts.garden.side_panel.button_add_virtual_patch')" @click="showVirtualPatchSelector = true" />
          <template #right>
            <rui-help-button>
              <rui-help-button-content :caption="$t('js.garden.toolbar.help.add.caption')" :content="$t('js.garden.toolbar.help.add.content')" :lines="help.add" />
            </rui-help-button>
          </template>
        </rui-toolbar>

        <rui-toolbar :label="$t('js.layouts.garden.toolbar.draw_path')" no-label-on-small>
          <rui-button icon="multiline-plus" :title="$t('js.layouts.garden.side_panel.button_draw_line')" @click="changeMode('select_path_style', { shape: 'LineString' })" />
          <rui-button icon="polygon-plus" :title="$t('js.layouts.garden.side_panel.button_draw_polygon')" @click="changeMode('select_path_style', { shape: 'Polygon' })" />
          <rui-button icon="circle-plus" :title="$t('js.layouts.garden.side_panel.button_draw_circle')" @click="changeMode('select_path_style', { shape: 'Circle' })" />
          <template #right>
            <rui-help-button>
              <rui-help-button-content :caption="$t('js.garden.toolbar.help.draw.caption')" :content="$t('js.garden.toolbar.help.draw.content')" :lines="help.draw" />
            </rui-help-button>
          </template>
        </rui-toolbar>
      </template>

      <rui-toolbar-spring />

      <rui-button v-if="activeLayer"
                  icon="layers"
                  class="-md:hidden"
                  :title="$t('js.layouts.garden.show_layers')"
                  no-text-on-small
                  @click="forceLayerPanelDisplay = !forceLayerPanelDisplay">
        {{ activeLayer.name }}
      </rui-button>
    </rui-toolbars>

    <div class="gpa-garden__view">
      <gp-map-controls :garden-map="gardenMap" />

      <div id="map" class="gpa-garden__view__map" :style="mapStyle" />

      <rui-panel class="gpa-garden__view__layers"
                 :class="forceLayerPanelDisplay ? 'gpa-garden__view__layers--visible' : ''"
                 @close="forceLayerPanelDisplay = false">
        <gpa-garden-right-panel :visible-layers="activeLayers"
                                :active-layer="activeLayer"
                                :is-drawing="!isReviewMode"
                                @activate="setActiveLayer"
                                @toggle="handleLayerVisibilityToggle" />
      </rui-panel>
    </div>

    <rui-drawer v-show="forceResourcePanelDisplay && mode === 'select_patch_resource'"
                :caption="$t('js.layouts.garden.resources')"
                :closeable="true"
                :overlay-closeable="false"
                @close="changeMode('review')">
      <gpa-resource-selector :selected-resource-id="previousResourceId"
                             :allow-null="modeOptions && modeOptions.skippable"
                             @cancel="changeMode('review')"
                             @choose="handleResourceSelection" />
    </rui-drawer>

    <rui-drawer v-show="forcePathPanelDisplay && mode === 'select_path_style'"
                :caption="$t('js.layouts.garden.path')"
                :closeable="true"
                :overlay-closeable="false"
                @close="changeMode('review')">
      <gpa-path-selector v-model="currentPathName"
                         :path-style="previousPathStyle"
                         @style-change="handleStyleSelection"
                         @cancel="changeMode('review')"
                         @close="forcePathPanelDisplay = false" />
    </rui-drawer>

    <rui-drawer v-show="showVirtualPatchSelector"
                :caption="$t('js.layouts.garden.integrate_virtual_patch')"
                :closeable="true"
                :overlay-closeable="false"
                @close="changeMode('review')">
      <gpa-virtual-patch-selector-form v-model="currentPathName"
                                       @cancel="changeMode('review')"
                                       @validate="handleDrawVirtualPatch"
                                       @close="forcePathPanelDisplay = false" />
    </rui-drawer>

    <div id="map-popup">
      <!-- Popup for paths -->
      <!-- Custom "mouse-xxx" events as they are not attached otherwise -->
      <gpa-path-popup v-if="pointedEntity && pointedEntity.className === 'Path'"
                      :path="pointedEntity"
                      @close="deselect" />
    </div>

    <div id="map-tooltip" class="ol-tooltip" />

    <!-- Drawer for patches -->
    <gpa-patch-drawer v-if="pointedEntity && pointedEntity.className === 'Patch'"
                      :patch="pointedEntity"
                      @close="deselect" />

    <!-- Drawer for elements -->
    <gpa-element-drawer v-if="pointedEntity && pointedEntity.className === 'Element'"
                        :element="pointedEntity"
                        @close="deselect" />

    <gpa-element-tooltip :element="hoveredElement" />
    <gpa-patch-tooltip :patch="hoveredPatch" />
    <gpa-path-tooltip :path="hoveredPath" />
  </div>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiDrawer from '@experiments-labs/rise_ui/src/components/Drawer/Drawer.vue'
import RuiHelpButton from '@experiments-labs/rise_ui/src/components/HelpButton/HelpButton.vue'
import RuiHelpButtonContent from '@experiments-labs/rise_ui/src/components/HelpButton/HelpButtonContent.vue'
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'
import RuiPanel from '@experiments-labs/rise_ui/src/components/Panel/Panel.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'
import RuiToolbars from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbars.vue'
import RuiToolbarSeparator from '@experiments-labs/rise_ui/src/components/Toolbar/ToolbarSeparator.vue'
import RuiToolbarSpring from '@experiments-labs/rise_ui/src/components/Toolbar/ToolbarSpring.vue'

import GpaElementDrawer from './Elements/_Drawer.vue'
import GardenMap from '../../../classes/GardenMap'
import Toaster from '../../../tools/Toaster'
import GpMapControls from '../../../common/MapControls/MapControls.vue'
import GpaGardenRightPanel from './Layouts/Garden/_RightPanel.vue'
import GpaPathSelector from './Paths/_Selector.vue'
import GpaResourceSelector from './Resources/Selector/Selector.vue'
import GpaPatchDrawer from './Patches/_Drawer.vue'
import GpaPathPopup from './Paths/_Popup.vue'
import GpaElementTooltip from '../../../../vue/apps/garden/components/Elements/_Tooltip.vue'
import GpaPatchTooltip from '../../../../vue/apps/garden/components/Patches/_Tooltip.vue'
import GpaPathTooltip from '../../../../vue/apps/garden/components/Paths/_Tooltip.vue'
import GpaVirtualPatchSelectorForm from '@/vue/apps/garden/components/Patches/_VirtualPatchSelectorForm.vue'

/**
 * @typedef {import('../../../classes/models/Layer')}    Layer
 * @typedef {import('../../../classes/models/Path')}     Path
 * @typedef {import('../../../classes/models/Patch')}    Patch
 * @typedef {import('../../../classes/models/Resource')} Resource
 */

export default {
  name: 'GpaGarden',
  components: {
    RuiHelpButtonContent,
    RuiHelpButton,
    RuiDrawer,
    RuiPanel,
    RuiToolbarSpring,
    RuiToolbarSeparator,
    RuiButton,
    RuiToolbar,
    RuiToolbars,
    RuiLoading,
    GpMapControls,
    GpaVirtualPatchSelectorForm,
    GpaPathTooltip,
    GpaPatchTooltip,
    GpaElementTooltip,
    GpaElementDrawer,
    GpaGardenRightPanel,
    GpaPathSelector,
    GpaPatchDrawer,
    GpaPathPopup,
    GpaResourceSelector,
  },
  data () {
    return {
      /** @type {string|null} Current mode */
      mode: null,
      /** @type {object|null} Current mode options */
      modeOptions: null,
      /** @type {string|null} Current transformation mode. Forced redraws are ignored as long as a tool is set */
      transformTool: null,
      /** @type {number|null} Previously selected resource */
      previousResourceId: null,
      /** @type {GardenMap} Map instance */
      gardenMap: null,
      /** @type {number[]} List of active layers */
      activeLayers: this.$store.getters.layers.map(l => l.id),
      /** @type {Layer|null} Active layer */
      activeLayer: null,
      /** @type {Patch|Path|Element} Active entity in review mode */
      pointedEntity: null,
      /** @type {Patch|Path|Element} Entity under cursor */
      hoveredEntity: null,
      /** @type {{strokeColor: string, backgroundColor: string, strokeWidth: number, strokeStylePreset: string|null}} Path style for path drawings */
      previousPathStyle: { strokeColor: '0,0,0,1', backgroundColor: '0,0,0,0.1', strokeWidth: 1, strokeStylePreset: null },
      /** @type {string|null} Path name for path creation */
      currentPathName: null,
      /** @type {boolean} Whether or not the map is loaded */
      mapIsReady: false,

      /** @type {boolean} Force display of side panel, independently of screen sizes */
      forceLayerPanelDisplay: false,
      forceResourcePanelDisplay: false,
      forcePathPanelDisplay: false,

      /** @type {boolean} Whether to display the form to add virtual patches to the map */
      showVirtualPatchSelector: false,

      help: {
        add: [
          { icon: 'point-plus', text: this.$t('js.garden.toolbar.help.add.point') },
          { icon: 'polygon-plus', text: this.$t('js.garden.toolbar.help.add.polygon') },
          { icon: 'circle-plus', text: this.$t('js.garden.toolbar.help.add.circle') },
          { icon: 'virtual', text: this.$t('js.garden.toolbar.help.add.virtual_patch') },
        ],
        draw: [
          { icon: 'multiline-plus', text: this.$t('js.garden.toolbar.help.draw.line') },
          { icon: 'polygon-plus', text: this.$t('js.garden.toolbar.help.draw.polygon') },
          { icon: 'circle-plus', text: this.$t('js.garden.toolbar.help.draw.circle') },
        ],
      },
    }
  },
  computed: {
    layers () { return this.$store.getters.layers },
    map () { return this.$store.getters.map(parseInt(this.$route.params.mapId, 10)) },
    mapStyle () {
      if (!this.map.backgroundColor) return ''

      return `background-color: ${this.map.backgroundColor}; background-image: none`
    },
    isReviewMode () { return ['review', null].includes(this.mode) },
    hoveredElement () { return this.hoveredEntity?.className === 'Element' ? this.hoveredEntity : null },
    hoveredPatch () { return this.hoveredEntity?.className === 'Patch' ? this.hoveredEntity : null },
    hoveredPath () { return this.hoveredEntity?.className === 'Path' ? this.hoveredEntity : null },
  },
  methods: {
    transformEntity (action, entity) {
      switch (action) {
        case 'translate':
          this.gardenMap.translateElement(entity)
          break
        case 'transform':
          this.gardenMap.transformElement(entity)
          break
        case 'rotate':
          this.gardenMap.rotateElement(entity)
          break
        default:
          throw new Error(`Unsupported action ${action}`)
      }

      this.transformTool = action
    },

    handleLayerVisibilityToggle (id) {
      const index = this.activeLayers.indexOf(id)
      if (index === -1) {
        this.activeLayers.push(id)
      } else {
        this.activeLayers.splice(index, 1)
      }

      this.gardenMap.setVisibleLayers(this.activeLayers)
    },
    setActiveLayer (layer) {
      this.activeLayer = layer
      this.gardenMap.useLayer(layer)
      // When drawing something, reset the drawing
      if (['draw_patch', 'draw_virtual_patch', 'draw_path'].includes(this.mode)) this.changeMode(this.mode, this.modeOptions)
    },

    checkForActiveLayer () {
      // There might be no active layer when user deleted the active one
      if (!this.activeLayer) {
        Toaster.error(this.$t('js.garden.layers.no_active_layer'))
        return false
      }
      return true
    },

    /**
     * Sets the active mode
     *
     * The mode determines the overall state of the UI
     *
     * @param {string} mode    - Mode name
     * @param {object} options - Mode options
     */
    changeMode (mode, options = null) {
      this.mode = mode
      this.modeOptions = options

      switch (mode) {
        case 'select_path_style':
          this.forcePathPanelDisplay = true
          break
        case 'draw_path':
          if (!this.checkForActiveLayer()) return
          this.gardenMap.drawPath(options.shape, options.style)
          break
        case 'select_patch_resource':
          this.forceResourcePanelDisplay = true
          break
        case 'draw_patch':
          if (!this.checkForActiveLayer()) return
          if (options.shape === 'Point') this.gardenMap.drawElement(options.resource)
          else this.gardenMap.drawPatch(options.shape, options.resource)
          break
        case 'draw_virtual_patch':
          if (!this.checkForActiveLayer()) return
          this.showVirtualPatchSelector = false
          this.gardenMap.drawVirtualPatch(options.shape, options.patch)
          break
        case 'review':
        default:
          this.gardenMap.review()
          break
      }
    },

    /**
     * Changes mode when a resource for a path/element is selected
     *
     * @param {Resource|null} resource - Resource to use in drawings
     */
    handleResourceSelection (resource) {
      this.previousResourceId = resource ? resource.id : null
      this.changeMode('draw_patch', { resource, shape: this.modeOptions.shape })
      this.forceResourcePanelDisplay = false
    },

    /**
     * Changes mode when a style for a path is selected
     *
     * @param {object} style - Style from the style selector
     */
    handleStyleSelection (style) {
      this.previousPathStyle = style
      this.changeMode('draw_path', { shape: this.modeOptions.shape, style })
    },

    /**
     * Saves the patch in database once it has been drawn
     *
     * @param {CustomEvent} event - The event
     */
    handleAddPatch (event) {
      const payload = {
        map_id: parseInt(this.$route.params.mapId, 10),
        geometry: event.detail.geoJSON,
        elements: [],
        layer_id: this.activeLayer.id,
      }
      if (event.detail.resourceId) payload.elements.push({ resource_id: event.detail.resourceId })

      this.$store.dispatch('createPatch', { payload: { patch: payload }, feature: event.detail.feature })
        .then(() => { Toaster.success(this.$t('js.patch.successfully_created')) })
        .catch(() => { Toaster.error(this.$t('js.patch.failed_to_create')) })
    },
    /**
     * Updates the patch in database once it changed
     *
     * @param {CustomEvent} event - The event
     */
    handleUpdatePatch (event) {
      const payload = {
        id: event.detail.id,
        geometry: event.detail.geoJSON,
      }
      this.$store.dispatch('updatePatch', { payload })
        // No need to update anything else for now.
        .then(() => { Toaster.success(this.$t('js.patch.successfully_updated')) })
        .catch(() => { Toaster.error(this.$t('js.patch.failed_to_update')) })
    },

    handleDrawVirtualPatch (event) {
      this.changeMode('draw_virtual_patch', { shape: event.shape, patch: event.patch })
    },
    handleAddVirtualPatch (event) {
      event.detail.patch.setFeature(event.detail.feature)
      event.detail.patch.layer_id = this.activeLayer.id

      const payload = {
        id: event.detail.patch.id,
        geometry: event.detail.geoJSON,
        layer_id: this.activeLayer.id,
      }
      this.$store.dispatch('updatePatch', { payload })
        .then(() => { Toaster.success(this.$t('js.patch.successfully_added_virtual_patch')) })
        .catch(() => { Toaster.error(this.$t('js.patch.failed_to_add_virtual_patch')) })
        .then(() => { this.changeMode('review') })
    },

    /**
     * Sets the pointed entity
     *
     * @param {CustomEvent} event - The event
     */
    handlePointEntity (event) {
      if (!event.detail || this.mode !== 'review') {
        this.deselect(false)
        return
      }
      const type = event.detail.type
      const id = event.detail.id
      this.pointedEntity = id ? this.$store.getters[type](id) : null
    },

    /**
     * Sets the hovered entity
     *
     * @param {CustomEvent} event - The event
     */
    handleHoverEntity (event) {
      if (!event.detail) {
        this.hoveredEntity = null
        return
      }

      this.hoveredEntity = event.detail.id ? this.$store.getters[event.detail.type](event.detail.id) : null
    },

    /**
     * Save the element in database once it has been drawn
     *
     * @param {CustomEvent} event - The event
     */
    handleAddElement (event) {
      const payload = {
        geometry: event.detail.geoJSON,
        resource_id: event.detail.resourceId,
        layer_id: this.activeLayer.id,
      }
      this.$store.dispatch('createElement', { payload, feature: event.detail.feature })
        .then(() => { Toaster.success(this.$t('js.element.successfully_created')) })
        .catch(() => { Toaster.error(this.$t('js.element.failed_to_create')) })
    },
    /**
     * Update the element in database once it changed
     *
     * @param {CustomEvent} event - The event
     */
    handleUpdateElement (event) {
      const payload = {
        id: event.detail.id,
        geometry: event.detail.geoJSON,
      }
      this.$store.dispatch('updateElement', payload)
      // No need to update anything else for now.
        .then(() => { Toaster.success(this.$t('js.element.successfully_updated')) })
        .catch(() => { Toaster.error(this.$t('js.element.failed_to_update')) })
    },

    /**
     * Saves the path in database once it has been drawn
     *
     * @param {CustomEvent} event - The event
     */
    handleAddPath (event) {
      const payload = {
        name: this.currentPathName,
        stroke_width: event.detail.strokeWidth,
        stroke_color: event.detail.strokeColor,
        stroke_style_preset: event.detail.strokeStylePreset,
        background_color: event.detail.backgroundColor,
        geometry: event.detail.geoJSON,
        layer_id: this.activeLayer.id,
        map_id: parseInt(this.$route.params.mapId, 10),
      }
      this.$store.dispatch('createPath', { payload: { path: payload }, feature: event.detail.feature })
        .then(() => {
          this.currentPathName = null
          Toaster.success(this.$t('js.path.successfully_created'))
        })
        .catch(() => { Toaster.error(this.$t('js.path.failed_to_create')) })
    },
    /**
     * Updates the path in database once it changed
     *
     * @param {CustomEvent} event - The event
     */
    handleUpdatePath (event) {
      const payload = {
        id: event.detail.id,
        geometry: event.detail.geoJSON,
      }
      this.$store.dispatch('updatePath', payload)
        // No need to update anything else for now.
        .then(() => { Toaster.success(this.$t('js.path.successfully_updated')) })
        .catch(() => { Toaster.error(this.$t('js.path.failed_to_update')) })
    },

    /**
     * Deselects the pointed entity
     *
     * @param {boolean} applyToMap - Whether to force the map to deselect items too. Should be false when used in response to a map event.
     */
    deselect (applyToMap = true) {
      this.pointedEntity = null
      if (applyToMap) {
        this.gardenMap.review()
      }
    },

    createMap () {
      // Everything has been loaded in _Layout.vue
      this.$nextTick(() => {
        const mapConfig = this.map
        this.gardenMap = new GardenMap(mapConfig, 'map', 'map-popup', 'map-tooltip')

        this.gardenMap.mapElement.addEventListener('ready', () => { this.mapIsReady = true })
        this.gardenMap.mapElement.addEventListener('point-entity', this.handlePointEntity)
        this.gardenMap.mapElement.addEventListener('hover-entity', this.handleHoverEntity)
        this.gardenMap.mapElement.addEventListener('add-patch', this.handleAddPatch)
        this.gardenMap.mapElement.addEventListener('add-virtual-patch', this.handleAddVirtualPatch)
        this.gardenMap.mapElement.addEventListener('update-patch', this.handleUpdatePatch)
        this.gardenMap.mapElement.addEventListener('add-element', this.handleAddElement)
        this.gardenMap.mapElement.addEventListener('update-element', this.handleUpdateElement)
        this.gardenMap.mapElement.addEventListener('add-path', this.handleAddPath)
        this.gardenMap.mapElement.addEventListener('update-path', this.handleUpdatePath)
        this.setActiveLayer(this.layers[0])

        this.changeMode('review')

        this.$onBus('layer-created', (layer) => {
          this.gardenMap.addLayer(layer)
          this.handleLayerVisibilityToggle(layer.id)
          // Select the new layer if wanted
          if (layer.visibleByDefault) this.setActiveLayer(layer)
        })
        this.$onBus('layer-destroyed', (layer) => {
          // Select another layer if needed
          if (layer.id === this.activeLayer.id) this.setActiveLayer(this.layers[0])

          this.gardenMap.removeLayer(layer)
        })
      })
    },
    destroyMap () {
      if (!this.gardenMap) return

      this.gardenMap.destroy()
      this.gardenMap = null
    },
  },
  created () {
    const that = this

    this.createMap()

    this.$onBus('destroyed-patch', (patch) => {
      this.deselect()
      this.gardenMap.removeEntityFeature(patch)
    }, 'garden')
    this.$onBus('rotate-patch', (patch) => { this.transformEntity('rotate', patch) }, 'garden')
    this.$onBus('move-patch', (patch) => { this.transformEntity('translate', patch) }, 'garden')
    this.$onBus('transform-patch', (patch) => { this.transformEntity('transform', patch) }, 'garden')

    this.$onBus('destroyed-path', (path) => {
      this.deselect()
      this.gardenMap.removeEntityFeature(path)
    }, 'garden')
    this.$onBus('rotate-path', (path) => { this.transformEntity('rotate', path) }, 'garden')
    this.$onBus('move-path', (path) => { this.transformEntity('translate', path) }, 'garden')
    this.$onBus('transform-path', (path) => { this.transformEntity('transform', path) }, 'garden')

    this.$onBus('destroyed-element', (element) => { this.gardenMap.removeEntityFeature(element) }, 'garden')
    this.$onBus('move-element', (element) => { this.transformEntity('translate', element) }, 'garden')

    this.$onBus('change-element-layer', ({ element, fromLayerId }) => {
      const layer = this.$store.getters.layer(fromLayerId)
      that.gardenMap.moveEntityToOtherLayer(layer, element)
    }, 'garden')
    this.$onBus('change-patch-layer', ({ patch, fromLayerId }) => {
      const layer = this.$store.getters.layer(fromLayerId)
      that.gardenMap.moveEntityToOtherLayer(layer, patch)
    }, 'garden')
    this.$onBus('change-path-layer', ({ path, fromPathId }) => {
      const layer = this.$store.getters.layer(fromPathId)
      that.gardenMap.moveEntityToOtherLayer(layer, path)
    }, 'garden')
    this.$onBus('virtualize-patch', (patch) => {
      this.changeMode('review')
      this.gardenMap.removeEntityFeature(patch)
    })
    this.$onBus('change-background-layer-visibility', () => {
      that.gardenMap.setBackgroundLayerVisibility()
    }, 'garden')
    this.$onBus('updated-element', (element) => {
      // Ignore updates when transforming the patch
      if (this.transformTool || !element.isPoint) return
      this.gardenMap.forceRedrawSelection(element)
    }, 'garden')
    this.$onBus('created-element', (element) => {
      if (element.isPoint) {
        // Add to the map
        this.gardenMap.addPlaceable(element)
      } else {
        // Redraw the patch
        const patch = element.displayName
        this.gardenMap.redrawEntity(patch)
      }
      this.gardenMap.forceRedrawSelection(element)
    }, 'garden')
    this.$onBus('updated-path', (path) => {
      // Ignore updates when transforming the path
      if (this.transformTool) return
      this.gardenMap.forceRedrawSelection(path)
    }, 'garden')
    this.$onBus('updated-patch', (patch) => {
      // Ignore updates when transforming the element
      if (this.transformTool) return
      this.gardenMap.forceRedrawSelection(patch)
    }, 'garden')
    this.$onBus('destroyed-patch-element', (element) => {
      // Ignore updates when transforming the element
      if (this.transformTool) return
      this.gardenMap.forceRedrawSelection(element.patch)
    }, 'garden')
  },
  beforeUnmount () {
    this.destroyMap()
    this.$unBusKey('garden')
  },
}
</script>

<style lang="scss" src="./Garden.scss" />
